Unit GSI1R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, GSU2R_p, GSN2R_p, SF35R_p;

function GSI1R(ISEED :Integer; N :Integer; P :Real): Real; 
implementation

function GSI1R(ISEED :Integer; N :Integer; P :Real): Real;
var
NS,J :Integer;
PS,A,GGBIN :Real;
const
SYS029 :Real = 0.70710678118654752440084436210485;
SYS037 :Real = 0.33333333333333333333333333333333;
CON1 :Real = 1.166335E-2;
RSPID3 :Real = 1.023327E0;
label
_1,_2,_3,_4,_5,_6;
begin
GGBIN := 0.0;
NS := N;
PS := P;
_1:
if ( NS < 15 ) 
 then goto _4;
if ( (NS Mod 2) <> 0 ) 
 then goto _2;
NS := NS-1;
if ( GSU2R(ISEED) <= PS ) 
 then GGBIN := GGBIN+1.0;
_2:
NS := NS div 2;
A := GSN2R(ISEED)/Sqrt((1.333333)*(NS+1)-SYS037);
A := (0.5*SF35R(-SYS029*A))*RSPID3+CON1;
if ( A <= PS ) 
 then goto _3;
PS := PS/A;
goto _1;
_3:
GGBIN := GGBIN+(NS+1);
PS := (PS-A)/(1.0-A);
goto _1;
_4:
if ( NS = 0 ) 
 then goto _6;
for J:=1 to NS do
 begin
  if ( GSU2R(ISEED) <= PS ) 
   then GGBIN := GGBIN+1.0;
_5:
 end;
_6:
Result := GGBIN;
end;

end.
